;rockyone			for M1-1 / M1-9			  29.03.2019
;
;
;			PI1 to PI3 with difthering
;			--------------------------
;		the color palette is not converted in this run
;
;
;Source 	address buffer image Pi1
;Destination	address	screen
;
;		call pi1_pi3(L source, L destination )
;
;
;a0,a3,a4	buffer source			
;a1-a2		buffer destination	
;used : d0-d7/a0-a4

		movem.l d0-d7/a0-a6,-(sp)
		movem.l	64(sp),a0-a1

		lea.l	80(a1),a2		; destination : odd line

		adda.w	#34,a0			; source
		lea.l	32000(a0),a4		; end of the pic
all_line:	lea.l	160(a0),a3		; end of a line

read_words:	movem.w	(a0)+,d0-d3
		andi.l	#$ffff,d0
		andi.l	#$ffff,d1
		andi.l	#$ffff,d2
		andi.l	#$ffff,d3
		move.l	#$8000,d4	; bit mask for conversion

bytes:		moveq.l	#0,d5		; registers for conversion
		moveq.l	#0,d6		;  "	"	"	"
		moveq.l	#15,d7		

w0:		cmp.l	d0,d4
		bgt.s	w2		; <d4
		bset.b	d7,d5	        ; bit 15,13,11...
		sub.w	d4,d0

w2:		cmp.l	d2,d4
		bgt.s	w1
		bset.b	d7,d6
		sub.w	d4,d2
				
w1:		subq.b	#1,d7		; 14,12.......0

		cmp.l	d1,d4
		bgt.s	w3
		bset.b	d7,d5		 
		sub.w	d4,d1

w3:		cmp.l	d3,d4
		bgt.s	next_bits
		bset.b	d7,d6
		sub.w	d4,d3

next_bits:	lsr.w	#1,d4
		subq.b	#1,d7		; 13,11......-1
		bpl.s	w0		

		move.w	d5,(a1)+
		move.w	d6,(a2)+

		tst.w	d4
		bhi.s	bytes		; loop once !

		cmpa.l	a0,a3		; end of the line ?
		bhi.s	read_words	; no

		movea.l	a2,a1			
		adda.w	#80,a2
		cmpa.l	a0,a4		; end of the pic ?
		bhi.s	all_line	; no


		movem.l	(sp)+,d0-d7/a0-a6
		rts
		end
;**************************************************************************